package com.waveinformatica.ocean.maven.plugin.dto;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import org.apache.commons.lang.StringUtils;

import com.google.gson.Gson;
import com.waveinformatica.ocean.core.internal.PersistenceConfigurationManager;
import com.waveinformatica.ocean.core.internal.PersistenceConfigurationManager.ConnectionType;
import com.waveinformatica.ocean.core.internal.PersistenceConfigurationManager.Element;
import com.waveinformatica.ocean.core.util.JsonUtils;

public class PropertiesGenerator {
	
	private final Map<String, Object> source;
	
	private SiteProperties site;
	private LoggingProperties logging;
	private SmtpProperties smtp;
	private PersistenceProperties persistence;
	private NetworkProperties network;
	private CachingProperties caching;
	private List<IdentityProperties> custom = new ArrayList<PropertiesGenerator.IdentityProperties>();
	
	public PropertiesGenerator(Map<String, Object> source) {
		this.source = source;
	}
	
	public void build() {
		
		Object siteSource = source.get("site");
		if (siteSource != null) {
			site = new SiteProperties((Map<String, Object>) source.get("site"));
		}
		Object loggingSource = source.get("logging");
		if (loggingSource != null) {
			logging = new LoggingProperties((Map<String, Object>) source.get("logging"));
		}
		Object smtpSource = source.get("smtp");
		if (smtpSource != null) {
			smtp = new SmtpProperties((Map<String, Object>) smtpSource);
		}
		Object persistenceSource = source.get("persistence");
		if (persistenceSource != null) {
			persistence = new PersistenceProperties((Map<String, Object>) persistenceSource);
		}
		Object networkSource = source.get("network");
		if (networkSource != null) {
			network = new NetworkProperties((Map<String, Object>) networkSource);
		}
		Object cachingSource = source.get("caches");
		if (cachingSource != null) {
			caching = new CachingProperties((List<Map<String, Object>>) source.get("caches"));
		}
		Map<String, Object> customSource = (Map<String, Object>) source.get("custom");
		if (customSource != null) {
			for (String k : customSource.keySet()) {
				custom.add(new IdentityProperties(k, (Map<String, Object>) customSource.get(k)));
			}
		}
		
	}
	
	public void writeAll(File configDir) throws IOException {
		
		write(site, configDir);
		write(logging, configDir);
		write(smtp, configDir);
		write(persistence, configDir);
		write(network, configDir);
		write(caching, configDir);
		for (IdentityProperties ip : custom) {
			write(ip, configDir);
		}
		
	}
	
	public void write(PropertiesProvider provider, File configDir) throws IOException {
		if (provider == null) {
			return;
		}
		
		System.out.println("         +--> " + provider.fileName());
		
		FileOutputStream fos = new FileOutputStream(new File(configDir, provider.fileName()));
		try {
			provider.toProperties().store(fos, "Generated by ocean-module-plugin on " + new SimpleDateFormat("dd MMM yyyy HH:mm:ss").format(new Date()));
		} finally {
			if (fos != null) {
				fos.close();
			}
		}
	}
	
	private interface PropertiesProvider {
		Properties toProperties();
		String fileName();
	}
	
	private static class SiteProperties implements PropertiesProvider {
		
		private String title;
		private String contextPath;
		private String url;
		private String theme;
		private boolean resourcesMerge;
		private String executorJndi;
		
		public SiteProperties(Map<String, Object> source) {
			
			title = asString(source.get("title"));
			contextPath = asString(source.get("contextPath"));
			url = asString(source.get("url"));
			theme = asString(source.get("theme"));
			resourcesMerge = asBoolean(source.get("resourcesMerge"));
			executorJndi = asString(source.get("executorJndi"));
		}
		
		public Properties toProperties() {
			Properties props = new Properties();
			props.setProperty("site-title", title);
			props.setProperty("site.contextPath", StringUtils.defaultIfBlank(contextPath, ""));
			props.setProperty("site.url", StringUtils.defaultIfBlank(url, "http://localhost:8080/"));
			props.setProperty("theme", StringUtils.defaultIfBlank(theme, ""));
			props.setProperty("resources.merge", resourcesMerge ? "true" : "false");
			if (StringUtils.isNotBlank(executorJndi)) {
				props.setProperty("concurrency.executor.jndi", executorJndi);
			}
			return props;
		}

		public String fileName() {
			return "site.properties";
		}
		
	}
	
	private static class LoggingProperties implements PropertiesProvider {
		
		private String feedbackRecipient;
		private String feedbackCode;
		private String feedbackSender;
		private String coreLevel;
		private Map<String, String> modules = new HashMap<String, String>();
		
		public LoggingProperties(Map<String, Object> source) {
			Map<String, Object> feedback = (Map<String, Object>) source.get("feedback");
			if (feedback != null) {
				feedbackRecipient = asString(feedback.get("recipient"));
				feedbackCode = asString(feedback.get("code"));
				feedbackSender = asString(feedback.get("sender"));
			}
			coreLevel = asString(source.get("core"));
			Map<String, Object> modules = (Map<String, Object>) source.get("modules");
			if (modules != null) {
				for (String k : modules.keySet()) {
					this.modules.put(k, asString(modules.get(k)));
				}
			}
		}
		
		public Properties toProperties() {
			Properties props = new Properties();
			props.setProperty("ocean.errors.feedback.recipient", StringUtils.defaultIfBlank(feedbackRecipient, "support@localhost"));
			props.setProperty("ocean.errors.feedback.application.code", StringUtils.defaultIfBlank(feedbackCode, "OCEAN-APP"));
			props.setProperty("ocean.errors.feedback.application.sender", StringUtils.defaultIfBlank(feedbackSender, "admin@localhost"));
			props.setProperty("core.level", StringUtils.defaultIfBlank(coreLevel, "INFO"));
			for (String k : modules.keySet()) {
				props.setProperty(k + ".level", modules.get(k));
			}
			return props;
		}

		public String fileName() {
			return "logging.properties";
		}
		
	}
	
	private static class SmtpProperties implements PropertiesProvider {
		
		private String host;
		private int port;
		private String userName;
		private String password;
		private boolean startTls;
		private String socketFactoryClass;
		private int socketFactoryPort;
		
		public SmtpProperties (Map<String, Object> source) {
			host = asString(source.get("host"));
			port = asInt(source.get("port"));
			userName = asString(source.get("user"));
			password = asString(source.get("password"));
			startTls = asBoolean(source.get("startTls"));
			Map<String, Object> socketFactory = (Map<String, Object>) source.get("socketFactory");
			if (socketFactory != null) {
				socketFactoryClass = asString(socketFactory.get("class"));
				socketFactoryPort = asInt(socketFactory.get("port"));
			}
		}

		public Properties toProperties() {
			Properties props = new Properties();
			props.setProperty("mail.smtp.host", host);
			props.setProperty("mail.smtp.port", port <= 0 ? "" : String.valueOf(port));
			props.setProperty("mail.user", userName);
			props.setProperty("mail.password", password);
			props.setProperty("mail.smtp.starttls.enable", startTls ? "true" : "false");
			props.setProperty("mail.smtp.socketFactory.class", StringUtils.defaultIfBlank(socketFactoryClass, ""));
			props.setProperty("mail.smtp.socketFactory.port", socketFactoryPort <= 0 ? "" : String.valueOf(socketFactoryPort));
			return props;
		}

		public String fileName() {
			return "smtp.properties";
		}
		
	}
	
	private static class PersistenceProperties implements PropertiesProvider {
		
		private String defaultConnection;
		private Map<String, Element> connections = new HashMap<String, PersistenceConfigurationManager.Element>();
		
		public PersistenceProperties(Map<String, Object> source) {
			defaultConnection = asString(source.get("default"));
			Map<String, Object> connections = (Map<String, Object>) source.get("connections");
			if (connections != null) {
				for (String k : connections.keySet()) {
					Map<String, Object> conn = (Map<String, Object>) connections.get(k);
					Element el = new Element();
					el.setConnectionName(k);
					el.setType(ConnectionType.valueOf(asString(conn.get("type"))));
					el.setDriverClass(asString(conn.get("driver")));
					el.setConnectionUrl(asString(conn.get("url")));
					el.setUserName(asString(conn.get("user")));
					el.setPassword(asString(conn.get("password")));
					el.setJndiName(asString(conn.get("jndi")));
					Map<String, Object> yamlProps = (Map<String, Object>) conn.get("properties");
					if (yamlProps != null) {
						for (String pk : yamlProps.keySet()) {
							el.getProperties().setProperty(pk, asString(yamlProps.get(pk)));
						}
					}
					this.connections.put(k, el);
				}
			}
		}

		public Properties toProperties() {
			Gson gson = JsonUtils.getBuilder().create();
			Properties props = new Properties();
			for (String k : connections.keySet()) {
				props.setProperty(k, gson.toJson(connections.get(k)));
			}
			if (StringUtils.isNotBlank(defaultConnection) && connections.get(defaultConnection) == null) {
				throw new IllegalArgumentException("defaultConnection \"" + defaultConnection + "\" not defined");
			}
			props.setProperty("ocean.persistence.defaultConnection", defaultConnection);
			return props;
		}

		public String fileName() {
			return "persistence.properties";
		}
		
	}
	
	private static class NetworkProperties implements PropertiesProvider {
		
		public final Map<String, String> proxies = new HashMap<String, String>();
		
		public NetworkProperties(Map<String, Object> source) {
			Map<String, Object> proxy = (Map<String, Object>) source.get("proxy");
			if (proxy != null) {
				for (String k : proxy.keySet()) {
					proxies.put(k, asString(proxy.get(k)));
				}
			}
		}

		public Properties toProperties() {
			Properties props = new Properties();
			for (String k : proxies.keySet()) {
				props.put("proxy." + k, props.get(k));
			}
			return props;
		}

		public String fileName() {
			return "network.properties";
		}
		
	}
	
	private static class CachingProperties implements PropertiesProvider {
		
		private Map<String, Map<String, Object>> props = new HashMap<String, Map<String,Object>>();
		
		public CachingProperties(List<Map<String, Object>> source) {
			Gson gson = JsonUtils.getBuilder().create();
			for (Map<String, Object> el : source) {
				String name = asString(el.get("name"));
				Map<String, Object> conf = new HashMap<String, Object>();
				props.put(name, conf);
				conf.put("providerName", asString(el.get("provider")));
				conf.put("configJson", gson.toJson(el.get("config")));
			}
		}

		public Properties toProperties() {
			Gson gson = JsonUtils.getBuilder().create();
			Properties result = new Properties();
			for (String k : props.keySet()) {
				result.put(k, gson.toJson(props.get(k)));
			}
			return result;
		}

		public String fileName() {
			return "caching.properties";
		}
		
	}
	
	private static class IdentityProperties implements PropertiesProvider {
		
		private final String name;
		private final Map<String, Object> content;
		
		public IdentityProperties(String name, Map<String, Object> content) {
			this.name = name;
			this.content = content;
		}
		
		public Properties toProperties() {
			Properties properties = new Properties();
			for (String k : content.keySet()) {
				properties.setProperty(k, asString(content.get(k)));
			}
			return properties;
		}

		public String fileName() {
			return "custom_" + name + ".properties";
		}
		
	}
	
	static String asString(Object v) {
		if (v == null) {
			return null;
		}
		else if (v instanceof String) {
			return (String) v;
		}
		else {
			return v.toString();
		}
	}
	
	static boolean asBoolean(Object v) {
		if (v instanceof String) {
			return "true".equals(v);
		}
		return Boolean.TRUE.equals(v) ? true : false;
	}
	
	static int asInt(Object v) {
		if (v instanceof String) {
			try {
				return Integer.parseInt((String) v);
			} catch (NumberFormatException e) {
				return -1;
			}
		}
		else if (v instanceof Number) {
			return ((Number) v).intValue();
		}
		else {
			return -2;
		}
	}
	
}
